#!/bin/bash
color_bit_depth="$1"

if [[ -z "$color_bit_depth" ]]
then
	echo "第一个参数为【颜色位深】，其值不能为空。其数值需要是 3 的倍数，且不能超过 24。" >&2
	exit 4
fi
mod="$(( $color_bit_depth % 3 ))"
if [[ ! "$mod" -eq 0 ]]
then
	echo "【颜色位深】数值需要是 3 的倍数。" >&2
	exit 4
fi
if [[ "$color_bit_depth" -gt 24 ]]
then
	echo "【颜色位深】数值不能超过 24。" >&2
	exit 4
fi

color_count=$(( 2 ** "$color_bit_depth" ))
echo "将会生成 $color_count 个颜色的样式的 xml 数据…" >&2

rgb_single_color_bit_depth=$(( $color_bit_depth / 3 ))
echo "单色位深 = $rgb_single_color_bit_depth" >&2
rgb_single_color_count=$(( 2 ** $rgb_single_color_bit_depth ))
rgb_single_color_mask=$(( $rgb_single_color_count - 1 ))
echo "单色数量 = $rgb_single_color_count" >&2

echo '<style:style style:name="cfsiDefault" style:family="table-cell" style:parent-style-name="Default"/>'
for ((r=0; r<=$rgb_single_color_mask; r++))
do
	for ((g=0; g<=$rgb_single_color_mask; g++))
	do
		for ((b=0; b<=$rgb_single_color_mask; b++))
		do
			r_8bit = $(( 255 * $r / $rgb_single_color_mask ))
			g_8bit = $(( 255 * $g / $rgb_single_color_mask ))
			b_8bit = $(( 255 * $b / $rgb_single_color_mask ))
			color_hex=$( printf "%02x%02x%02x" $r_8bit $g_8bit $b_8bit )
			# cfsi: Conditional Formatting Style Index
			echo '<style:style style:name="cfsi'${color_hex}'" style:family="table-cell" style:parent-style-name="cfsiDefault"><style:table-cell-properties fo:background-color="#'${color_hex}'"/><style:text-properties fo:color="#'${color_hex}'"/></style:style>'
		done
	done
done
